#
# note: disabling plugins will still build them if deps are met
#
# Conditional build:
%bcond_without	exec		# do not build exec plugin
%bcond_without	rdp		# do not build rdp plugin
%bcond_without	secret		# do not build secret plugin
%bcond_without	spice		# do not build spice plugin
%bcond_without	vnc		# do not build vnc plugin
%bcond_without	vte		# do not build vte plugin
%bcond_without	www		# do not build www plugin
#
Summary:	Remote Desktop Client
Name:		remmina
Version:	1.4.28
Release:	1
License:	GPLv2+ and MIT
Group:		X11/Applications
Source0:	https://gitlab.com/Remmina/Remmina/-/archive/v%{version}/Remmina-v%{version}.tar.bz2
# Source0-md5:	6cd0c29ce48218d0fdda79d51232c73e
# Cmake helper file to easy build plugins outside remmina source tree
# See http://www.muflone.com/remmina-plugin-rdesktop/english/install.html which
# use http://www.muflone.com/remmina-plugin-builder/ with remmina bundled source.
# So we can't use it directly only as instructions.
Source1:	pluginBuild-CMakeLists.txt
Patch0:		fix-shebangs.patch
URL:		http://remmina.org
BuildRequires:	appstream-glib
BuildRequires:	avahi-ui-gtk3-devel >= 0.6.30
BuildRequires:	cmake >= 2.8
BuildRequires:	cups-devel
BuildRequires:	desktop-file-utils
%{?with_rdp:BuildRequires:	freerdp2-devel >= 2.0.0-0.20190320}
BuildRequires:	gettext
BuildRequires:	gtk+3-devel
%{?with_www:BuildRequires:      gtk-webkit4-devel}
BuildRequires:	intltool
BuildRequires:	json-glib-devel
BuildRequires:	libappindicator-gtk3-devel
BuildRequires:	libgcrypt-devel
%{?with_secret:BuildRequires:	libsecret-devel}
BuildRequires:	libsodium-devel
BuildRequires:	libsoup-devel
%{?with_vnc:BuildRequires:	libvncserver-devel}
BuildRequires:	pcre2-8-devel
BuildRequires:	python3-devel
BuildRequires:	rpmbuild(macros) >= 1.742
%{?with_spice:BuildRequires:	spice-gtk-devel}
%{?with_vte:BuildRequires:	vte-devel}
BuildRequires:	xorg-lib-libxkbfile-devel
Requires(post,postun):	gtk-update-icon-cache
Requires:	avahi-ui-gtk3 >= 0.6.30
Requires:	hicolor-icon-theme
Obsoletes:	remmina-plugins-nx < 1.4.20
Obsoletes:	remmina-plugins-xdmcp < 1.4.20
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

Remmina supports multiple network protocols in an integrated and
consistent user interface. Currently RDP, VNC, XDMCP and SSH are
supported.

Please don't forget to install the plugins for the protocols you want
to use.

%package        devel
Summary:	Development files for %{name}
Requires:	%{name} = %{version}-%{release}
Requires:	pkgconfig

%description    devel
The %{name}-devel package contains header files for developing plugins
for %{name}.

%package        plugins-exec
Summary:	External execution plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}

%description    plugins-exec
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the plugin to execute external processes
(commands or applications) from the Remmina window.

%package        plugins-python_wrapper
Summary:	Python Wrapper plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}
Requires:	freerdp2-libs >= 2.0.0-0.20190320

%description    plugins-python_wrapper
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package enables Python plugins for Remmina.

%package        plugins-rdp
Summary:	RDP plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}
Requires:	freerdp2-libs >= 2.0.0-0.20190320

%description    plugins-rdp
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the Remote Desktop Protocol (RDP) plugin for the
Remmina remote desktop client.

%package        plugins-secret
Summary:	Keyring integration for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-plugins-gnome%{?_isa} = %{version}-%{release}
Obsoletes:	remmina-plugins-gnome < %{version}-%{release}

%description    plugins-secret
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the plugin with keyring support for the Remmina
remote desktop client.

%package        plugins-spice
Summary:	SPICE plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}

%description    plugins-spice
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the SPICE plugin for the Remmina remote desktop
client.

%package        plugins-vnc
Summary:	VNC plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}

%description    plugins-vnc
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the VNC plugin for the Remmina remote desktop
client.

%package        plugins-www
Summary:	Browser plugin for Remmina Remote Desktop Client
Requires:	%{name} = %{version}-%{release}

%description    plugins-www
Remmina is a remote desktop client written in GTK+, aiming to be
useful for system administrators and travelers, who need to work with
lots of remote computers in front of either large monitors or tiny
net-books.

This package contains the www plugin for the Remmina remote desktop
client.

%prep
%setup -qn Remmina-v%{version}
%{__sed} -i s/^pt_PT$// po/LINGUAS
%{__rm} -f po/pt_PT.po
%patch0 -p1

%build
mkdir -p build
cd build
%cmake \
	-DCMAKE_INSTALL_LIBDIR=%{_lib} \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DWITH_APPINDICATOR=ON \
	-DWITH_AVAHI=ON \
	-DWITH_CUPS=ON \
	-DWITH_GCRYPT=ON \
	-DWITH_GETTEXT=ON \
	-DWITH_LIBSECRET=ON \
	%{cmake_on_off vnc WITH_LIBVNCSERVER} \
	%{cmake_on_off spice WITH_SPICE} \
	%{cmake_on_off vte WITH_VTE} \
	..

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
cd build
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT
cd ..

install -d $RPM_BUILD_ROOT%{_libdir}/cmake/%{name}/
cp -pr cmake/*.cmake $RPM_BUILD_ROOT%{_libdir}/cmake/%{name}/
cp -pr config.h.in $RPM_BUILD_ROOT%{_includedir}/%{name}/
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_includedir}/%{name}/

# not supported by glibc yet
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/{ber,br,ckb,eo,ie,ka,hi,shn}

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_icon_cache hicolor

%postun
%update_icon_cache hicolor

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc LICENSE AUTHORS ChangeLog README.md
%attr(755,root,root) %{_bindir}/remmina-file-wrapper
%attr(755,root,root) %{_bindir}/remmina
%{_datadir}/metainfo/*.appdata.xml
%{_desktopdir}/*.desktop
%{_iconsdir}/hicolor/*/actions/*.*
%{_iconsdir}/hicolor/*/apps/*.*
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-sftp-symbolic.svg
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-ssh-symbolic.svg
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-tool-symbolic.svg
%{_iconsdir}/hicolor/*/status/org.remmina.Remmina-status.svg
%dir %{_iconsdir}/hicolor/apps
%{_iconsdir}/hicolor/apps/*.*
%{_datadir}/mime/packages/*.xml
%{_datadir}/%{name}/
%dir %{_libdir}/remmina/
%dir %{_libdir}/remmina/plugins/
%{_mandir}/man1/remmina.1*
%{_mandir}/man1/remmina-file-wrapper.1*

%files devel
%defattr(644,root,root,755)
%{_includedir}/%{name}/
%{_pkgconfigdir}/%{name}.pc
%dir %{_libdir}/cmake/%{name}
%{_libdir}/cmake/%{name}/*.cmake

%if %{with exec}
%files plugins-exec
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-exec.so
%endif

%files plugins-python_wrapper
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-python_wrapper.so

%if %{with rdp}
%files plugins-rdp
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-rdp.so
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-rdp-ssh-symbolic.svg
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-rdp-symbolic.svg
%endif

%if %{with secret}
%files plugins-secret
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-secret.so
%endif

%if %{with spice}
%files plugins-spice
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-spice.so
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-spice-symbolic.svg
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-spice-ssh-symbolic.svg
%endif

%if %{with vnc}
%files plugins-vnc
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-vnc.so
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-vnc-ssh-symbolic.svg
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-vnc-symbolic.svg
%endif

%if %{with www}
%files plugins-www
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/remmina/plugins/remmina-plugin-www.so
%{_iconsdir}/hicolor/*/emblems/org.remmina.Remmina-www-symbolic.svg
%endif

%changelog
* Fri Dec 02 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/remmina.git;a=log;h=master

* Fri Dec 02 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> eddcfe7
- up to 1.4.28

* Mon Jun 20 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> f68e105
- up to 1.4.27

* Mon Apr 04 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 801405c
- up to 1.4.25

* Fri Mar 04 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 43d9808
- 1.4.24

* Sun Jan 09 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> a889ce2
- up to 1.4.23

* Wed Oct 27 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> a10659f
- up to 1.4.21

* Fri Sep 24 2021 Jan Rękorajski <baggins@pld-linux.org> bc16b02
- rebuild with openssl 3.0.0

* Sat Jul 17 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> b422c8c
- up to 1.4.20; removing plugins/st,xdmcp,nx as per the project's changelog

* Fri Jul 02 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> c24c876
- up to 1.4.19

* Wed Jun 09 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 1f7e9b0
- up to 1.4.18

* Fri May 28 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 57873ca
- up to 1.4.17

* Fri Apr 09 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 0a05815
- up to 1.4.13

* Sat Mar 06 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> bc85955
- up to 1.4.12

* Mon Feb 08 2021 Krzysztof Mrozowicz <mrozowik@pld-linux.org> ff85521
- up to 1.4.11

* Thu Dec 31 2020 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 0221137
- up to 1.4.10

* Fri Oct 30 2020 Jan Palus <atler@pld-linux.org> 4556405
- runtime libssh dep only if built with nx

* Fri Aug 28 2020 Krzysztof Mrozowicz <mrozowik@pld-linux.org> e742415
- up to 1.4.8

* Mon Aug 03 2020 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 1c51192
- removed telepathy plugin (as there is no way to switch it on to build), fixed cmake_on_off variables

* Sat Aug 01 2020 Jan Rękorajski <baggins@pld-linux.org> 88561a4
- don't disable libssh twice

* Mon Jul 27 2020 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 7fc1103
- fixed conditional build of NX plugin

